{% extends "crud.html" %}


{% block top_records_navigation %}
    <div class="col"></div>
{% endblock %}


{% block add_form %}
<div class="row">
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label><b>{{ "product_code"|normalize|title }}*</b></label>
                    <select name="formula_no" class="form-control" data-ajax-select-target="/api/v1/formulas/all?valid=True&fields=product_code,description,variant,standard_packing_per_piece,standard_specific_gravity" data-ajax-select-value="_id" data-ajax-select-label="product_code,description,variant" placeholder="-- Select Product Code --" required placeholder="-- Select Product Code --">
                        <option value="">-- Select Product Code --</option>
                    </select>
                </div>
            </div>
        </div>
    </div>
    <div class="col-12 col-md-6">
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label><b>{{ "batch_size"|normalize|title }} (in kg)*</b></label>
                    <input type="number" name="batch_size" class="form-control" min="0" required data-default-value="0" value="0" />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "batch_no"|normalize|title }}*</label>
                    <input type="text" name="batch_no" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
        <div class="row">
            <div class="col-12">
                <div class="form-group">
                    <label>{{ "purchase_order_no"|normalize|title }}*</label>
                    <input type="text" name="purchase_order_no" class="form-control" oninput="this.value = this.value.toUpperCase()" maxlength="32" required />
                </div>
            </div>
        </div>
    </div>
</div>
<div class="row">
    <div class="col-12">
        <h5>Raw Materials</h5>
        <table class="table table-striped table-hover table-bordered">
            <thead>
                <tr>
                    <th>Item Code</th>
                    <th>Description</th>
                    <th>Unit</th>
                    <th>%</th>
                    <th>Required</th>
                    <th>Stock on Hand</th>
                    <th>On Hold</th>
                    <th>Delta</th>
                </tr>
            </thead>
            <tbody data-materials-editable-container="raw_materials"></tbody>
            <tfoot>
                <tr>
                    <td>Total</td>
                    <td>--</td>
                    <td>--</td>
                    <td class="text-right">0</td>
                    <td class="text-right">0</td>
                    <td>--</td>
                    <td>--</td>
                    <td>--</td>
                </tr>
            </tfoot>
        </table>
    </div>
</div>
<div class="row">
    <div class="col-12">
        <h5>Packaging Materials</h5>
        <table class="table table-striped table-hover table-bordered">
            <thead>
                <tr>
                    <th>Item Code</th>
                    <th>Description</th>
                    <th>Unit</th>
                    <th>Pc</th>
                    <th>Required</th>
                    <th>Stock on Hand</th>
                    <th>On Hold</th>
                    <th>Delta</th>
                </tr>
            </thead>
            <tbody data-materials-editable-container="packaging_materials"></tbody>
        </table>
    </div>
</div>
{% endblock %}


{% block empty_spiel %}
    Add Manufacturing Orders using Formulas as basis
    <br />
    Finished goods are derived from these.
{% endblock %}


{% block read_columns %}
{# <script> #}
    {
        data: 'manufacturing_order_no',
        render: function(data) {
            return '<a href="javascript:;avascript:;" data-crud-toggle="details" class="font-weight-bold" aria-expanded="true"> #{0}</a>'.format(data);
        }
    },
    {
        data: 'formula_no'
    },
    {
        data: 'batch_size'
    },
    {
        data: 'date_created'
    },
    {
        data: 'status',
        render: function(data) {
            switch(data) {
                case 0:
                    return 'Draft';
                case 1:
                    return 'Submitted to QA/RnD';
                case -1:
                    return 'Void';
                default:
                    return 'N/A';
            }
        }
    },
    {
        data: 'status',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            switch (data) {
                case 0:
                    return '<a href="javascript:;" class="btn btn-warning btn-sm btn-block" data-manufacturing-toggle="submit" data-submit-target="{0}"> Submit to QA/RnD</a>'.format(row._id);
                case 1:
                    return '<a href="javascript:;" class="btn btn-warning btn-sm btn-block" data-manufacturing-toggle="print-picking-slip" data-print-target="{0}"><i class="fa fa-fw fa-print"></i> Picking Slip</a>'.format(row._id);
                default:
                    return '';
            }
        }
    },
    {
        data: 'status',
        sortable: false,
        className: 'text-center',
        render: function(data, type, row) {
            switch (data) {
                case 0:
                    return '<a href="javascript:;" class="btn btn-danger btn-sm btn-block" data-crud="delete" data-delete-target="{0}"><i class="fa fa-trash fa-fw"></i> Delete</a>'.format(row._id);
                default:
                    return '<a href="javascript:;" class="btn btn-secondary btn-sm btn-block" data-manufacturing-toggle="print-summary" data-print-target="{0}"><i class="fa fa-fw fa-print"></i> Summary</a>'.format(row._id);
            }
        }
    }
{# </script> #}
{% endblock %}


{% block sub_scripts %}
{# <script> #}
    var standard_packing_per_piece, standard_specific_gravity;
    $dom.document.on('change', 'select[name="formula_no"]', function() {
        let _id = $(this).val();
        let crud = $(this).closest('[data-crud]').attr('data-crud');
        if (_id !== '' && _id !== null) {
            $.get('/api/v1/formulas?_id={0}&fields=raw_materials,packaging_materials,standard_packing_per_piece,standard_specific_gravity'.format(_id), function() {})
            .done(function(response) {
                standard_packing_per_piece = parseFloat(response.standard_packing_per_piece);
                standard_specific_gravity = parseFloat(response.standard_specific_gravity);
                $('[data-crud="{0}"] input[type="number"][name="batch_size"]'.format(crud)).closest('.form-group').showCustom();

                if ($('[data-crud="{0}"] [data-materials-editable-container]'.format(crud)).length) {
                    let totals = {};
                    let xhrs = {};
                    let rows = {};
                    $.each(['raw_materials', 'packaging_materials'], function(i1, category) {
                        $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).html('<tr><td colspan="8">Loading...</td></tr>');
                        $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).siblings('tfoot').find('tr:first td:eq(3)').html('');
                        $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).siblings('tfoot').find('tr:first td:eq(4)').html('');
                        totals[category] = 0;
                        xhrs[category] = [];
                        rows[category] = Array(response[category].length);
                        $.each(response[category], function(i2, v) {
                            xhrs[category].push(
                                (function() {
                                    return $.get('/api/v1/raw_materials?_id={0}&fields=item_code,description,default_unit,stock_on_hand,stock_on_hold,status'.format(v.item_code), function() {})
                                    .done(function(response2) {
                                        totals[category] += parseFloat(v.quantity);
                                        let factor = 0;
                                        if (category === 'raw_materials') {
                                            factor = parseFloat(v.quantity) / 100;
                                        } else {
                                            factor = parseFloat(v.quantity);
                                        }
                                        rows[category][v.index] = `
                                            <tr data-form-dynamic>
                                                <td>{0}</td>
                                                <td>{1}</td>
                                                <td>{2}</td>
                                                <td class="text-right">{3}</td>
                                                <td class="text-right" data-factor="{4}"></td>
                                                <td class="text-right">{5}</td>
                                                <td class="text-right">{6}</td>
                                                <td class="text-right"></td>
                                            </tr>`.format(
                                                response2.item_code,
                                                response2.description,
                                                response2.default_unit,
                                                parseFloat(v.quantity).toFixed(6),
                                                factor,
                                                parseFloat(response2.stock_on_hand).toFixed(6),
                                                parseFloat(response2.stock_on_hold).toFixed(6)
                                        );
                                    });
                                })()
                            )
                        });

                        $.when.apply(null, xhrs[category]).then(function() {
                            $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).html(rows[category].join(''));
                            $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).siblings('tfoot').find('tr:first td:eq(3)').html(totals[category].toFixed(6));
                            $('[data-crud="{0}"] input[name="batch_size"]'.format(crud)).resetCustom();
                        })
                    });
                }
                if ($('[data-crud="{0}"] [data-materials-container]'.format(crud)).length) {
                    manufacturing_order_id = $dom.crud.details.find('form input[type="hidden"][name="_id"]').val();
                    let xhrs = {};
                    let rows = {};
                    $.each(['raw_materials', 'packaging_materials'], function(i1, category) {
                        $('[data-crud="{0}"] [data-materials-container="{1}"]'.format(crud, category)).html('<tr><td colspan="8">Loading...</td></tr>');
                        xhrs[category] = [];
                        rows[category] = Array(response[category].length);
                        $.each(response[category], function(i2, v) {
                            xhrs[category].push(
                                (function() {
                                    return $.get('/api/v1/inventory_transactions?raw_material={0}&type=used&manufacturing_order={1}&fields=cumulative_quantity,raw_material,used_quality_control_nos,'.format(v.item_code, manufacturing_order_id), function() {})
                                    .done(function(response2) {
                                        rows[category][v.index] = `
                                            <tr data-form-dynamic>
                                                <td>{0}</td>
                                                <td>{1}</td>
                                                <td>{2}</td>
                                                <td>{3}</td>
                                                <td>{4}</td>
                                            </tr>`.format(
                                                response2.raw_material.item_code,
                                                response2.raw_material.description,
                                                response2.raw_material.default_unit,
                                                Math.abs(response2.cumulative_quantity).toFixed(6),
                                                response2.used_quality_control_nos.join('<br />')
                                        );
                                    })
                                })()
                            )
                        });

                        $.when.apply(null, xhrs[category]).then(function() {
                            $('[data-crud="{0}"] [data-materials-container="{1}"]'.format(crud, category)).html(rows[category].join(''));
                            if (crud == 'details') {
                                $('[data-crud="{0}"] input[type="number"][name="batch_size"]'.format(crud)).attr('readonly', '');
                                $('[data-crud="{0}"] input[type="number"][name="formula_no"]'.format(crud)).attr('disabled', '');
                            }
                        })
                    });
                }
            })
            .fail(function(response) {
                console.log('error ajax')
            });
        } else {
            standard_packing_per_piece = 0;
            standard_specific_gravity = 0;
            $('[data-crud="{0}"] [data-materials-editable-container]'.format(crud)).html('');
            $('[data-crud="{0}"] input[type="number"][name="batch_size"]'.format(crud)).closest('.form-group').hideCustom();
        }
    });

    $dom.document.on('keyup mouseup input', 'input[type="number"][name="batch_size"]', function() {
        let value = $(this).val();
        if (value === '') {
            value = 0;
        }
        let crud = $(this).closest('[data-crud]').attr('data-crud');
        let input_bulk = parseFloat(value);
        let required = parseFloat(0);
        let totals = {};

        $.each(['raw_materials', 'packaging_materials'], function(i1, category) {
            totals[category] = parseFloat(0);
            if (category === 'packaging_materials') {
                {# percentage or pc / specific gravity / packing per piece * 1000 (i.e. 1000ml in 1 L) #}
                input_bulk = input_bulk / standard_specific_gravity / standard_packing_per_piece * 1000;
                input_bulk = Math.floor(input_bulk);
            } else {
                {# assume raw materials and bulk quantity in kg) #}
            }
            $.each($('[data-crud="{0}"] [data-materials-editable-container={1}] tr[data-form-dynamic]'.format(crud, category)), function(i2, v) {
                let factor = parseFloat($(v).find('[data-factor]').attr('data-factor'));
                required = input_bulk * factor;

                $(v).find('td:eq(4)').html(required.toFixed(6));
                totals[category] += required;

                let stock_on_hand = $(v).find('td:eq(5)').html();
                if (stock_on_hand == '--') {
                    $(v).find('td:eq(7)').html('--');
                } else {
                    delta = parseFloat($(v).find('td:eq(5)').html()) + parseFloat($(v).find('td:eq(6)').html()) - required;
                    $(v).find('td:eq(7)').html(delta.toFixed(6));
                }
            });
            $('[data-crud="{0}"] [data-materials-editable-container="{1}"]'.format(crud, category)).siblings('tfoot').find('tr:first td:eq(4)').html(Math.round(totals[category]));
        });
    });

    $dom.document.on('click', '[data-manufacturing-toggle="submit"]', function() {
        $self = $(this);
        Swal.fire({
            type: 'question',
            title: 'Submit to QA/RnD?',
            text: 'Changes will not be accepted after submission',
            showCancelButton: true,
            focusCancel: true,
            confirmButtonText: 'Yes'
        }).then((result) => {
            if (result.value) {
                $.post('{{ url_for(".change_status", _id="placeholder") }}'.replace('placeholder', $self.attr('data-submit-target')), {'status': 1}, function() {})
                .done(function(response) {
                    if (isDefined(response.success) && response.success) {
                        Swal.fire('Submitted Successfully', '', 'success');
                    }
                    else {
                        Swal.fire('Error', response.error, 'error');
                    }
                })
                .always(function() {
                    $dom.datatables.records.reload('submit report');
                })
                .fail(function() {
                    Swal.fire('Error', 'Server Error', 'error');
                });
            }
        });
    });

    $dom.document.on('click', '[data-manufacturing-toggle="print-summary"]', function() {
        $self = $(this);
        window.location.replace('{{ url_for(".print_summary", _id="placeholder") }}'.replace('placeholder', $self.attr('data-print-target')));
    });

    $dom.document.on('click', '[data-manufacturing-toggle="print-picking-slip"]', function() {
        $self = $(this);
        window.location.replace('{{ url_for(".print_picking_slip", _id="placeholder") }}'.replace('placeholder', $self.attr('data-print-target')));
    });
{# </script> #}
{% endblock %}
